/*
 *    file: CGContext.h
 *  author: Bastian Spiegel <bs@tkscript.de>
 *
 * changed: 21Nov2007, 26Dec2007
 *
 * license: MIT
 *
Copyright (c) 2007-2008 Bastian Spiegel, Carsten Busse

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

*/


#ifndef __TKCG_CONTEXT_H__
#define __TKCG_CONTEXT_H__

YG("CG");

YC class _CGContext : public _CGObject {

   // Note: The following lines are NOT comments!
//#define CG_COMPILE_MANUAL YCI CG_COMPILE_MANUAL
//#define CG_COMPILE_IMMEDIATE YCI CG_COMPILE_IMMEDIATE
//#define CG_COMPILE_LAZY YCI CG_COMPILE_LAZY


  public:
   CGcontext   cg_context;
   _CGProfile *fragment_profile; // Default profile for new fragment programs
   _CGProfile *vertex_profile; // Default profile for new vertex programs

  public:
   _CGContext(void);
   ~_CGContext();

   YAC(_CGContext);

   _CGhandle getCgHandle (void);
   void      setCgHandle (_CGhandle);

   void createProgramFromLocalFile(YAC_Object *_fileName, YAC_Object *_entry, YAC_Object *_args, YAC_Value *_r, 
                                   CGenum _programType, _CGProfile *_profile);

   void createProgramFromString(YAC_Object *_string, YAC_Object *_entry, YAC_Object *_args, YAC_Value *_r, 
                                CGenum _programType, _CGProfile *_profile);

   YM void create                               (void);
   YM void destroy                              (void);
   YM void setFragmentProfile                   (YAC_Object *_profile);
   YM void setVertexProfile                     (YAC_Object *_profile);
   YM void createVertexProgramFromSource        (YAC_Object *_source, YAC_Object *_entry, YAC_Object *_args, YAC_Value *_r);
   YM void createVertexProgramFromLocalSource   (YAC_Object *_fileName, YAC_Object *_entry, YAC_Object *_args, YAC_Value *_r);
   YM void createVertexProgramFromLocalObject   (YAC_Object *_fileName, YAC_Object *_entry, YAC_Object *_args, YAC_Value *_r);
   YM void createFragmentProgramFromSource      (YAC_Object *_source, YAC_Object *_entry, YAC_Object *_args, YAC_Value *_r);
   YM void createFragmentProgramFromLocalSource (YAC_Object *_fileName, YAC_Object *_entry, YAC_Object *_args, YAC_Value *_r);
   YM void createFragmentProgramFromLocalObject (YAC_Object *_fileName, YAC_Object *_entry, YAC_Object *_args, YAC_Value *_r);
   // void createVertexProgramFromObject(YAC_Object *_objectBuffer, YAC_Object *_entry, YAC_Object *_args, YAC_Value *_r);
   // void createVertexProgramFromLogicSource(YAC_Object *_fileName, YAC_Object *_entry, YAC_Object *_args, YAC_Value *_r);
   // void createVertexProgramFromLogicObject(YAC_Object *_fileName, YAC_Object *_entry, YAC_Object *_args, YAC_Value *_r);

   YM sSI  getManageTextureParameters           (void);
   YM void setManageTextureParameters           (sSI);
   YM void registerStates                       (void);
   YM void createEffectFromLocalFile            (YAC_Object *_fileName, YAC_Object *_args, YAC_Value *_r);
   YM void createParameter                      (sSI _cgType, YAC_Value *_r); // see _CGParameter for supported cg datatypes
   YM void setAutoCompile                       (sSI _autoCompileMode);
   YM void getLastListing                       (YAC_Value *_r);
   YM void createState                          (YAC_Object *_name, sSI _cgType, YAC_Value *_r);
   
};


#endif // __TKCG_CONTEXT_H__

