/*
 *    file: CGEffect.h
 *  author: Bastian Spiegel <bs@tkscript.de>
 *
 * changed: 21Nov2007, 26Dec2007
 *
 * license: MIT
 *
Copyright (c) 2007-2008 Bastian Spiegel, Carsten Busse

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

*/

#ifndef __TKCG_EFFECT_H_
#define __TKCG_EFFECT_H_

YG("CG");


YC class _CGEffect : public _CGObject {
  public:
   CGeffect cg_effect;

  public:
   _CGEffect(void);
   ~_CGEffect();

   YAC(_CGEffect);

   _CGhandle getCgHandle (void);
   void      setCgHandle (_CGhandle);

   void destroy(void);
   void init(CGeffect _cgEffect);

   YM void        createParameter      (YAC_String *_name, sSI _cgType, YAC_Value *_r); // see _CGParameter for supported cg datatypes
   YM void        createFloatParameter (YAC_String *_name, YAC_Value *_r);
   YM void        getName              (YAC_Value *_r);
   YM void        getContext           (YAC_Value *_r);
   
};



#endif // __TKCG_EFFECT_H_
