/*
 *    file: CGParameter.h
 *  author: Bastian Spiegel <bs@tkscript.de>
 *
 * changed: 21Nov2007, 26Dec2007
 *
 * license: MIT
 *
Copyright (c) 2007-2008 Bastian Spiegel, Carsten Busse

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

*/

#ifndef __TKCG_PARAMETER_H__
#define __TKCG_PARAMETER_H__

YG("CG");

YC class _CGParameter : public _CGObject {

//the following lines are -NO- comments
//#define CG_GL_MATRIX_IDENTITY YCI 0
//#define CG_GL_MODELVIEW_PROJECTION_MATRIX YCI 7
//#define CG_HALF YCI CG_HALF
//#define CG_FLOAT YCI CG_FLOAT
//#define CG_FLOAT2 YCI CG_FLOAT2
//#define CG_FLOAT3 YCI CG_FLOAT3
//#define CG_FLOAT4 YCI CG_FLOAT4
//#define CG_FLOAT1x1 YCI CG_FLOAT1x1
//#define CG_FLOAT1x2 YCI CG_FLOAT1x2
//#define CG_FLOAT1x3 YCI CG_FLOAT1x3
//#define CG_FLOAT1x4 YCI CG_FLOAT1x4
//#define CG_FLOAT2x1 YCI CG_FLOAT2x1
//#define CG_FLOAT2x2 YCI CG_FLOAT2x2
//#define CG_FLOAT2x3 YCI CG_FLOAT2x3
//#define CG_FLOAT2x4 YCI CG_FLOAT2x4
//#define CG_FLOAT3x1 YCI CG_FLOAT3x1
//#define CG_FLOAT3x2 YCI CG_FLOAT3x2
//#define CG_FLOAT3x3 YCI CG_FLOAT3x3
//#define CG_FLOAT3x4 YCI CG_FLOAT3x4
//#define CG_FLOAT4x1 YCI CG_FLOAT4x1
//#define CG_FLOAT4x2 YCI CG_FLOAT4x2
//#define CG_FLOAT4x3 YCI CG_FLOAT4x3
//#define CG_FLOAT4x4 YCI CG_FLOAT4x4
//#define CG_SAMPLER1D YCI CG_SAMPLER1D
//#define CG_SAMPLER2D YCI CG_SAMPLER2D
//#define CG_SAMPLER3D YCI CG_SAMPLER3D
//#define CG_SAMPLERRECT YCI CG_SAMPLERRECT
//#define CG_SAMPLERCUBE YCI CG_SAMPLERCUBE
//#define CG_INT YCI CG_INT
//#define CG_INT1x1 YCI CG_INT1x1
//#define CG_INT1x2 YCI CG_INT1x2
//#define CG_INT1x3 YCI CG_INT1x3
//#define CG_INT1x4 YCI CG_INT1x4
//#define CG_INT2x1 YCI CG_INT2x1
//#define CG_INT2x2 YCI CG_INT2x2
//#define CG_INT2x3 YCI CG_INT2x3
//#define CG_INT2x4 YCI CG_INT2x4
//#define CG_INT3x1 YCI CG_INT3x1
//#define CG_INT3x2 YCI CG_INT3x2
//#define CG_INT3x3 YCI CG_INT3x3
//#define CG_INT3x4 YCI CG_INT3x4
//#define CG_INT4x1 YCI CG_INT4x1
//#define CG_INT4x2 YCI CG_INT4x2
//#define CG_INT4x3 YCI CG_INT4x3
//#define CG_INT4x4 YCI CG_INT4x4
//#define CG_BOOL YCI CG_BOOL
//#define CG_BOOL1x1 YCI CG_BOOL1x1
//#define CG_BOOL1x2 YCI CG_BOOL1x2
//#define CG_BOOL1x3 YCI CG_BOOL1x3
//#define CG_BOOL1x4 YCI CG_BOOL1x4
//#define CG_BOOL2x1 YCI CG_BOOL2x1
//#define CG_BOOL2x2 YCI CG_BOOL2x2
//#define CG_BOOL2x3 YCI CG_BOOL2x3
//#define CG_BOOL2x4 YCI CG_BOOL2x4
//#define CG_BOOL3x1 YCI CG_BOOL3x1
//#define CG_BOOL3x2 YCI CG_BOOL3x2
//#define CG_BOOL3x3 YCI CG_BOOL3x3
//#define CG_BOOL3x4 YCI CG_BOOL3x4
//#define CG_BOOL4x1 YCI CG_BOOL4x1
//#define CG_BOOL4x2 YCI CG_BOOL4x2
//#define CG_BOOL4x3 YCI CG_BOOL4x3
//#define CG_BOOL4x4 YCI CG_BOOL4x4
//#define CG_STRING YCI CG_STRING
//#define CG_PROGRAM_TYPE YCI CG_PROGRAM_TYPE
//#define CG_TEXTURE YCI CG_TEXTURE


  public:
   CGparameter cg_parameter;

   YAC_Object *texture_val;

  public:
   _CGParameter();
   ~_CGParameter();

   YAC(_CGParameter);

   _CGhandle getCgHandle (void);
   void      setCgHandle (_CGhandle);

   void init(CGparameter _cgParameter);
   void destroy(void);
   void setnf(YAC_Object *_array, sUI _num, const char *_oobMsg);
   void setni(YAC_Object *_array, sUI _num, const char *_oobMsg);
   void getMatrixf(YAC_Object *_faRet, bool _bRow);
   void getMatrixd(YAC_Object *_noaRet, bool _bRow);
   void setMatrixf(YAC_Object *_fa, bool _bRow);
   void setMatrixd(YAC_Object *_noa, bool _bRow);

   YM sSI  isReferenced           (void);
   YM void enableTexture          (void);
   YM void disableTexture         (void);
   YM void setStateMatrix         (sSI _a, sSI _b);
   YM void setTexture             (YAC_Object *_texture);
   YM void setupSampler           (YAC_Object *_texture);
   YM YAC_Object *getTexture      (void);
   YM sSI  getTextureId           (void);
   YM void set1i                  (sSI _a);
   YM void set1iv                 (YAC_Object *_a);
   YM void set1f                  (sF32 _a);
   YM void set1fv                 (YAC_Object *_a);
   YM void set2i                  (sSI _a, sSI _b);
   YM void set2iv                 (YAC_Object *_a);
   YM void set2f                  (sF32 _a, sF32 _b);
   YM void set2fv                 (YAC_Object *_a);
   YM void set3i                  (sSI _a, sSI _b, sSI _c);
   YM void set3iv                 (YAC_Object *_a);
   YM void set3f                  (sF32 _a, sF32 _b, sF32 _c);
   YM void set3fv                 (YAC_Object *_a);
   YM void set4i                  (sSI _a, sSI _b, sSI _c, sSI _d);
   YM void set4iv                 (YAC_Object *_a);
   YM void set4f                  (sF32 _a, sF32 _b, sF32 _c, sF32 _d);
   YM void set4fv                 (YAC_Object *_a);
   YM void enableClientState      (void);
   YM void disableClientState     (void);
   YM void getMatrixfr            (YAC_Object *_faRet);
   YM void getMatrixfc            (YAC_Object *_faRet);
   YM void getMatrixdr            (YAC_Object *_noaRet);
   YM void getMatrixdc            (YAC_Object *_noaRet);
   YM sSI  getTextureEnum         (void);
   YM void setMatrixfr            (YAC_Object *_fa);
   YM void setMatrixfc            (YAC_Object *_fa);
   YM void setMatrixdr            (YAC_Object *_noa);
   YM void setMatrixdc            (YAC_Object *_noa);
   YM void disconnect             (void);
   YM void getConnectedParameter  (YAC_Value *_r);
   YM void getConnectedToParameter(sSI _index, YAC_Value *_r);
   YM void connectTo              (YAC_Object *_cgParameter);
};

#endif // __TKCG_PARAMETER_H__

