/*
 *    file: CGProfile.h
 *  author: Bastian Spiegel <bs@tkscript.de>
 *
 * changed: 21Nov2007, 26Dec2007
 *
 * license: MIT
 *
Copyright (c) 2007-2008 Bastian Spiegel, Carsten Busse

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

*/

#ifndef __TKCG_PROFILE_H__
#define __TKCG_PROFILE_H__

YG("CG");


YC class _CGProfile : public YAC_Object {

   // Do not delete the following lines, they are not comments!
//#define CG_PROFILE_VP20 YCI CG_PROFILE_VP20
//#define CG_PROFILE_FP20 YCI CG_PROFILE_FP20
//#define CG_PROFILE_VP30 YCI CG_PROFILE_VP30
//#define CG_PROFILE_FP30 YCI CG_PROFILE_FP30
//#define CG_PROFILE_ARGVP1 YCI CG_PROFILE_ARBVP1
//#define CG_PROFILE_VP40 YCI CG_PROFILE_VP40
//#define CG_PROFILE_GLSLV YCI CG_PROFILE_GLSLV
//#define CG_PROFILE_GLSLF YCI CG_PROFILE_GLSLF
//#define CG_PROFILE_GLSLC YCI CG_PROFILE_GLSLC


  public:
   CGprofile cg_profile;

  public:
   _CGProfile(void);
   ~_CGProfile();

   YAC(_CGProfile);

   YM void setId                    (sSI _profileId);
   YM sSI  getId                    (void);
   YM sSI  isSupported              (void);
   YM void getLatestVertexProfile   (void);
   YM void getLatestFragmentProfile (void);
   YM void setOptimalOptions        (void);
   YM void enable                   (void);
   YM void disable                  (void);
   YM void unbindProgram            (void);
   
};


#endif // __TKCG_PROFILE_H__
